Bug 252227 - gcl fails with segmentation fault. selinux prevents gcl from performing a text relocation.
gcl fails with segmentation fault. selinux prevents gcl from performing a te...
Product: Fedora
Classification: Fedora
Component: gcl (Show other bugs)
x86_64 Linux
low Severity urgent
: ---
: ---
Assigned To: Gérard Milmeister
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2007-08-14 16:03 EDT by Mark Harig
Modified: 2007-11-30 17:12 EST (History)
0 users

See Also:
Fixed In Version: 2.6.7-15.fc7
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2007-08-20 12:03:19 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Mark Harig 2007-08-14 16:03:06 EDT
Description of problem:
gcl fails to start, but instead fails with a segmentation fault.  Shortly
thereafter, the setroubleshoot browser signals that it has a new message about
why selinux prevented gcl from running.

Version-Release number of selected component (if applicable):
  $ rpm -q gcl selinux-policy selinux-policy-targeted

How reproducible:
Always, i.e., every time I enter 'gcl' at the bash shell prompt.

Steps to Reproduce:
1. Enter 'gcl' at the bash shell prompt.
Actual results:
"Segmentation fault"

Expected results:
gcl interpreter should start, followed by the interpreter's prompt.

Additional info:
The setroubleshoot browser provides the following detailed description:

"The /usr/lib/gcl-2.6.7/unixport/saved_ansi_gcl application attempted to load
/usr/lib/gcl-2.6.7/unixport/saved_ansi_gcl which requires text relocation. This
is a potential security problem. Most libraries do not need this permission.
Libraries are sometimes coded incorrectly and request this permission. The
SELinux Memory Protection Tests web page explains how to remove this
requirement. You can configure SELinux temporarily to allow
/usr/lib/gcl-2.6.7/unixport/saved_ansi_gcl to use relocation as a workaround,
until the library is fixed. Please file a bug report against this package."
Comment 1 Gérard Milmeister 2007-08-14 16:21:03 EDT
Try "/sbin/restorecon -r /usr/lib/gcl-2.6.7".
Comment 2 Mark Harig 2007-08-14 16:31:00 EDT
I can do that, but should it be necessary?  (I'm not too knowledgeable about
selinux -- I use the default Fedora settings.)  By comparison, neither sbcl nor
clisp have this problem:

   $ rpm -q sbcl clisp

Both start without problems and without my having created special selinux
settings.  In addition, sbcl and clisp put their libraries in, respectively,


while 'gcl' puts its libraries in /usr/lib/gcl-2.6.7.
Comment 3 Mark Harig 2007-08-14 16:35:59 EDT
This did not fix the problem.  Here is the result (run as 'root'):

# /sbin/restorecon -r /usr/lib/gcl-2.6.7
# echo $?
# gcl
Segmentation fault
Comment 4 Gérard Milmeister 2007-08-14 17:25:00 EDT
The post-install script of the gcl package takes care of the selinux business.
I found the problem now, the script uses the wrong path on 64-bit platforms.
I will make a new build ASAP. This will appear in updates-testing. Please try
it from there and report back.
Comment 5 Mark Harig 2007-08-14 18:03:23 EDT
I will attempt to check it today.
Comment 6 Fedora Update System 2007-08-15 15:42:12 EDT
gcl-2.6.7-15.fc7 has been pushed to the Fedora 7 testing repository.  If problems still persist, please make note of it in this bug report.
Comment 7 Mark Harig 2007-08-15 18:04:57 EDT
I have enabled the 'fedora-updates-testing.repo', but 'gcl' is not appearing as
an available package for download.  Is it possible that only the 'i386' version
is available while the 'x86_64' version is not?
Comment 8 Gérard Milmeister 2007-08-16 05:51:27 EDT
It takes a little time for the mirrors to sync, so try again.
Comment 9 Mark Harig 2007-08-16 11:01:51 EDT
I have installed the (x86_64) test version via 'yum install'.  gcl no longer
fails with a segmentation fault.  I started the interpreter, evaluated several
expressions, and exited the interpreter without any errors, and then repeated
that  startup-eval-shutdown sequence several times without seeing any errors. 
There were also no error messages displayed in /var/log/messages or
/var/log/secure, and the setroubleshoot program does not have any new reports.

The problem that I reported appears to have been fixed.  Thank you!

(Note: The x86_64 gcl library files are still installed in '/usr/lib/' instead
of '/usr/lib64'.)
Comment 10 Fedora Update System 2007-08-20 12:03:16 EDT
gcl-2.6.7-15.fc7 has been pushed to the Fedora 7 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.